<template>
  <!-- The search box for pieces -->
  <!-- list item is clickable so user can go to search even when the sidebar is closed -->
  <v-list-item @click="autoComplete.focus()">
    <v-list-item-icon @click="isMinified=false">
      <v-icon>mdi-magnify</v-icon>
    </v-list-item-icon>
    <v-autocomplete
      ref="autoComplete"
      attach
      return-object
      :placeholder="$t('piece-search-box.placeholder.search')"
      hide-details solo
      :filter="pieceSearchFilter"
      :item-text="getPieceTextVersion"
      :loading="!isLoading"
      :items="pieces"
      :menu-props="{
        maxHeight: 600,
        closeOnContentClick: true
      }"
    >
      <template #item="{item: piece}">
        <v-list-item
          dense
          @click="(e) => goTo(e, piece)"
        >
          <v-list-item-content>
            <v-list-item-subtitle
              v-text="piece.getMetadataCollection($i18n.locale, piece)"
            />
            <v-list-item-title
              v-text="piece.getPieceTitle($i18n.locale, piece)"
            />
            <v-list-item-title v-text="title(piece)" />
            <!-- TODO: Reduce calls to getPieceDetails -->
            <!-- currently: 2 * N * redraw -->
            <v-list-item-subtitle
              v-text="piece.getMetadataOne($i18n.locale, piece)"
            />
            <v-list-item-subtitle
              v-text="piece.getContents($i18n, piece)"
            />
            <div class="available-sources">
              <corpus-table-available-sources
                :available-sources="{
                  audioQuality: piece.audioQuality,
                  curatedAnalyses: piece.curatedAnalyses,
                  availableSources: piece.availableSources,
                  availableTracks: piece.availableTracks,
                  availableScores: piece.availableScores,
                  availableWaves: piece.availableWaves
                }"
              />
            </div>
          </v-list-item-content>
        </v-list-item>
      </template>
    </v-autocomplete>
  </v-list-item>
</template>

<script lang="ts">
import {
  Vue, Component, Watch, Prop, Ref, VModel,
} from 'vue-property-decorator';
import type { Piece } from '@/data';
import { getIndexPieceAlt, getPieceLink, removeLast } from '@/vuejs/components/utils/nav-tools';
import type { Client } from '@/client';
import { ClientStatus } from '@/client';
import { warnPieceServer } from '@/components/dialogs';
import CorpusTableAvailableSources from '@/components/CorpusTableAvailableSources.vue';

/**
 * Loads and display a list of pieces from a list of clients
 * Pieces are sorted by the order of the clients
 * Pieces can be filtered through props
 */
@Component({
  components: {
    CorpusTableAvailableSources,
  },
})
export default class PieceSearchBox extends Vue {
  pieces: Piece[] = [];

  isLoading = true;

  @Prop()
  clients!: Client[];

  @Prop({ default: getPieceLink })
  getLink!: (p: Piece) => string;

  @Prop({ default: null })
  pieceFilter!: (p: Piece) => boolean;

  @VModel()
  isMinified!: boolean;

  async created() {
    return this.tryLoadCorpus();
  }

  pieceSearchFilter(piece: Piece, filter: string, textVersion: string): boolean {
    // Then use search to filter out pieces
    const words = filter
      .toLowerCase()
      .trim()
      .split(' ')
      .filter((s) => !!s);
    return words.every((word) => textVersion.includes(word));
  }

  title(piece: Piece): string {
    return piece.getTitle(this.$i18n.locale);
  }

  getPieceTextVersion(piece: Piece): string {
    return `
${piece.composer}
${this.title(piece)}
${piece.path}
${JSON.stringify(piece.opus)}
${piece.signature.pretty}
`.toLowerCase();
  }

  @Watch('clients', { deep: true })
  async tryLoadCorpus(): Promise<void> {
    // Try to load the pieces of every client
    const corpusPromises = this.clients.map((c) => this.loadCorpus(c));
    // Awaits all corpuses
    const piecesArrays = await Promise.all(corpusPromises);
    // Flatten pieces
    let pieces = piecesArrays.flat();
    // Filter pieces if necessary
    if (this.pieceFilter) pieces = pieces.filter(this.pieceFilter);

    // Sort them
    this.pieces = pieces.sort((a, b) => (a.getSortKey()).localeCompare(b.getSortKey()));
  }

  /** Try to load the corpus from a single client
   * Handles unauth as best as possible
   * Returns an empty array if not data is available
  */
  async loadCorpus(client: Client): Promise<Piece[]> {
    const corpus = await client.loadCorpus();

    if (corpus.isOk()) return corpus.data.pieces;

    // If error might be due to old tokens, try again
    if (
      client.canLogin // If on a loggable client
      && client.user // If client currently has an auth token
      && corpus.isErr() // If the request failed
      && corpus.status === ClientStatus.Unauth // If it failed due to auth reasons
    ) {
      // eslint-disable-next-line no-console
      console.error('Not authorized, trying again after logging out');
      // Try again after logout
      Vue.set(client, 'user', null);
      return this.loadCorpus(client);
    }

    warnPieceServer();
    // eslint-disable-next-line no-console
    console.error(corpus.error);
    // return empty array
    return [];
  }

  goTo(e: MouseEvent, piece: Piece) {
    const url = this.getLink(piece);
    e.preventDefault();
    if (this.$store.state.corpusId !== removeLast(piece.path, '/')) {
      this.dispatch(piece);
    }
    this.updateIndex(piece);
    if (e.ctrlKey) {
      window.open(url, '_blank');
    } else {
      if (url === this.$route.path) return;
      this.$store.dispatch('updateAllowedToPlay', {
        allowedToPlay: false,
      });
      this.$router.push(url);
    }
  }

  dispatch(piece: Piece) {
    this.$store.dispatch('updateCorpus', {
      corpus: [piece],
      corpusId: null,
    });
  }

  updateIndex(piece: Piece) {
    this.$store.dispatch('updateIndexCurrentPiece', {
      indexCurrentPiece: getIndexPieceAlt(piece, this.$store.state.corpus),
    });
  }

  /** The ref of the auto complete box, for focus */
  @Ref()
  autoComplete!: HTMLElement;
}

</script>

<style lang="scss" scoped>
.available-sources {
  position: absolute;
  top: 5px;
  right: 10px;
}
</style>
